10  REM
20  REM                      MICROSTRIP DESIGN PROGRAM
30  REM                      -------------------------
40  REM                         BY KEVIN MCCLANING
50  REM
60  REM     THIS PROGRAM IS BASED ON THE ARTICLE "SYNTHESIZE AND ANALYZE
70  REM MICROSTRIP LINES BY JAMES J. LEV, MICROWAVES AND RF MAGAZINE,
80  REM JANUARY 1986, PG 111.
90  REM
100  REM
110  REM
120  CLS:PRINT
130  PRINT"                 MICROSTRIP DESIGN PROGRAM"
140  PRINT"                 -------------------------"
150  PRINT
160  PRINT "    THIS PROGRAM ALLOWS THE USER TO DESIGN MICROSTRIP TRANSMISSION"
170  PRINT "LINES FROM USER-SUPPLIED PHYSICAL PARAMETERS."
180  PRINT
190  PRINT "    NOTE: THE EQUATIONS USED IN THIS PROGRAM ARE FIRST-"
200  PRINT "ORDER APPROXIMATIONS, BUT THEY SHOULD BE OK FOR INITIAL DESIGNS."
210  GOSUB 820
220  PRINT "WHAT'LL IT BE:"
230  PRINT "  1 - COMPUTE RELATIVE DIELECTRIC CONSTANT FROM MEASURED"
240  PRINT "              PHYSICAL PARAMETERS"
250  PRINT "  2 - FIND THE WIDTH OF A MICROSTRIP T-LINE"
260  PRINT "  3 - END"
270  INPUT ANS
280  IF ANS = 1 THEN 320
290  IF ANS = 2 THEN 570
300  IF ANS = 3 THEN END
310  BEEP:GOTO 210
320  REM
330  REM
340  REM
350  REM         FIND RELATIVE DIELECTRIC CONSTANT
360  REM
370  REM
380  GOSUB 820:PRINT
390  PRINT "FIND RELATIVE DIELECTRIC CONSTANT":PRINT
400  INPUT "ENTER THE AREA OF THE BOARD (SQUARE INCHES)";AREASI
410  AREA = AREASI*(0.0254)*(0.0254)
420  INPUT "ENTER THE THICKNESS OF THE DIELECTRIC (INCHES)";DTHICKI
430  DTHICK = DTHICKI*0.0254
440  INPUT "ENTER THE MEASURED CAPACITANCE (pF)";CAPPF
450  CAP = CAPPF*0
460  ESUBR = (CAP*DTHICK)/(AREA*0)
470  GOSUB 860
480  PRINT "WHAT'LL IT BE:"
490  PRINT "  1 - FIND ANOTHER RELATIVE DIELECTRIC CONSTANT"
500  PRINT "  2 - PRINT"
510  PRINT "  3 - MAIN MENU"
520  INPUT ANS
530  IF ANS = 1 THEN 380
540  IF ANS = 2 THEN GOSUB 940:GOSUB 820:GOTO 480
550  IF ANS = 3 THEN 210
560  BEEP:GOTO 480
570  REM
580  REM
590  REM
600  REM         COMPUTE THE WIDTH OF A MICROSTRIP SECTION
610  REM
620  REM
630  GOSUB 820:PRINT
640  PRINT "COMPUTE WIDTH OF A MICROSTRIP SECTION":PRINT
650  INPUT "ENTER THE EFFECTIVE DIELECTRIC CONSTANT";ESUBR
660  INPUT "ENTER THE THICKNESS OF THE DIELECTRIC (INCHES)";DTHICKI
670  DTHICK = DTHICKI*0.0254
680  INPUT "ENTER THE DESIRED CHARACTERISTIC IMPEDENCE (OHMS)";Z0
690  TEMP = EXP(Z0*SQR(1+ESUBR)/42.4)-1
700  TOP = 8*SQR(TEMP*((7+(4/ESUBR))/11)+((1+(1/ESUBR))/0.81))
710  TWIDTH = DTHICKI*TOP/TEMP
720  GOSUB 1010
730  PRINT "WHAT'LL IT BE:"
740  PRINT "  1 - FIND ANOTHER MICROSTRIP T-LINE WIDTH"
750  PRINT "  2 - PRINT"
760  PRINT "  3 - MAIN MENU"
770  INPUT ANS
780  IF ANS = 1 THEN 630
790  IF ANS = 2 THEN GOSUB 1080:GOSUB 820:GOTO 730
800  IF ANS = 3 THEN 210
810  BEEP:GOTO 730
820  PRINT "----------------------------":RETURN
830  REM
840  LPRINT "----------------------------":RETURN
850  REM
860  GOSUB 820
870  PRINT "RELATIVE DIELECTRIC CONSTANT"
880  PRINT "    BOARD AREA = ";AREASI;" SQUARE INCHES"
890  PRINT "    DIELECTRIC THICKNESS = ";DTHICKI;" INCHES"
900  PRINT "    MEASURED CAPACITANCE = ";CAPPF;" pF"
910  PRINT "    RELATIVE DIELECTRIC CONSTANT = ";INT(ESUBR*1000)/1000
920  GOSUB 820:RETURN
930  REM
940  GOSUB 840
950  LPRINT "RELATIVE DIELECTRIC CONSTANT"
960  LPRINT "    BOARD AREA = ";AREASI;" SQUARE INCHES"
970  LPRINT "    DIELECTRIC THICKNESS = ";DTHICKI;" INCHES"
980  LPRINT "    MEASURED CAPACITANCE = ";CAPPF;" pF"
990  LPRINT "    RELATIVE DIELECTRIC CONSTANT = ";INT(ESUBR*1000)/1000
1000  GOSUB 840:RETURN
1010  GOSUB 820
1020  PRINT "WIDTH OF A MICROSTRIP T-LINE (Z0 = ";Z0;" OHMS)"
1030  PRINT "    DIELECTRIC THICKNESS = ";DTHICKI;" INCHES"
1040  PRINT "    RELATIVE DIELECTRIC CONSTANT = ";INT(ESUBR*1000)/1000
1050  PRINT "    COMPUTED WIDTH = ";INT(1000*TWIDTH)/1000;" INCHES"
1060  GOSUB 820:RETURN
1070  REM
1080  GOSUB 840
1090  LPRINT "WIDTH OF A MICROSTRIP T-LINE (Z0 = ";Z0;" OHMS)"
1100  LPRINT "    DIELECTRIC THICKNESS = ";DTHICKI;" INCHES"
1110  LPRINT "    RELATIVE DIELECTRIC CONSTANT = ";INT(ESUBR*1000)/1000
1120  LPRINT "    COMPUTED WIDTH = ";INT(1000*TWIDTH)/1000;" INCHES"
1130  GOSUB 840:RETURN
